/*
 * Created on 2004-11-14
 */

package crn;

/**
 * An interface to allow specific IEs comparison.
 * @author Piotrek
 */
public interface IEComparator
{
	/**
	 * Compares two IEs. The returned value is a similarity percentage and therefore must be in range [0..1].
	 * @author Piotrek
	 * @param ie1 The first of the IEs to be compared.
	 * @param ie2 The second of the IEs to be compared.
	 * @return The similarity measure of these two IEs or -1 in case of any error (like the value was not of the expected type).
	 */
	public float CompareIEs(IE ie1, IE ie2);
}
