/*
 * Created on 2005-06-18
 */
package crn.comparators;

import crn.IE;
import crn.IEComparator;

/**
 * A class used to compare the changes counts.
 * @author Piotrek
 */
public class ChangesCountsComparator implements IEComparator
{
	/**
	 * @see crn.IEComparator#CompareIEs(crn.IE, crn.IE)
	 * @author Piotrek
	 */
	public float CompareIEs(IE ie1, IE ie2)
	{
		if (ie1 == null || ie2 == null)
			throw new NullPointerException("Both IEs must not be null in ChangesCountsComparator.");
		
		if (ie1.name.compareTo("ChangesCount") != 0 || ie2.name.compareTo("ChangesCount") != 0)
			throw new IllegalArgumentException("Changes counts comparator compares only change counts.");
		
		int changesCount1 = Integer.parseInt(ie1.value);
		int changesCount2 = Integer.parseInt(ie2.value);
		
		int difference = Math.abs(changesCount1 - changesCount2);
		
		if (difference > MAX_SIMILAR_CHANGES_COUNTS_DIFFERENCE)
			return 0;
		
		return 1.0f - (float)difference / (float)MAX_SIMILAR_CHANGES_COUNTS_DIFFERENCE;
	}

	/**
	 * Defines the maximal difference between similar changes counts.
	 * @author Piotrek
	 */
	public static int MAX_SIMILAR_CHANGES_COUNTS_DIFFERENCE = 3;
}
