/*
 * Created on 2005-06-17
 */
package crn.comparators;

import crn.IE;
import crn.IEComparator;

/**
 * A class used to compare departure hours of day.
 * @author Piotrek
 */
public class DepartureHoursOfDayComparator implements IEComparator
{
	
	/**
	 * @see crn.IEComparator#CompareIEs(crn.IE, crn.IE)
	 * @author Piotrek
	 */
	public float CompareIEs(IE ie1, IE ie2)
	{
		if (ie1 == null || ie2 == null)
			throw new NullPointerException("Both IEs must not be null in DepartureHoursOfDayComparator.");
		
		if (ie1.name.compareTo("DepartureHourOfDay") != 0 || ie2.name.compareTo("DepartureHourOfDay") != 0)
			throw new IllegalArgumentException("Illegal IE type in DepartureHoursOfDayComparator.");
		
		int hour1 = Integer.parseInt(ie1.value);
		int hour2 = Integer.parseInt(ie2.value);
		
		int difference = Math.abs(hour1 - hour2);
		
		if (difference > MAX_SIMILAR_HOURS_DIFFERENCE)
			return 0;
		
		return 1.0f - (float)difference / (float)MAX_SIMILAR_HOURS_DIFFERENCE;
	}
	
	/**
	 * Defines the maximal difference between two similar hours.
	 * @author Piotrek
	 */
	
	public static int MAX_SIMILAR_HOURS_DIFFERENCE = 10;
}
