/*
 * Created on 2005-06-17
 */
package crn.comparators;

import crn.IE;
import crn.IEComparator;

/**
 * A class used to compare the ranks of means of transportation.
 * @author Piotrek
 */
public class RanksComparator implements IEComparator
{	
	/**
	 * @see crn.IEComparator#CompareIEs(crn.IE, crn.IE)
	 * @author Piotrek
	 */
	public float CompareIEs(IE ie1, IE ie2)
	{
		if (ie1 == null || ie2 == null)
			throw new NullPointerException("Both IEs must not be null in RanksComparator.");
		
		if (ie1.name.indexOf("Rank") != ie1.name.length() - 4 || ie2.name.indexOf("Rank") != ie2.name.length() - 4)
			throw new IllegalArgumentException("Ranks comparator compares only ranks.");
		
		int rank1 = Integer.parseInt(ie1.value);
		int rank2 = Integer.parseInt(ie2.value);
		
		int difference = Math.abs(rank1 - rank2);
		
		if (difference > MAX_SIMILAR_RANKS_DIFFERENCE)
			return 0;
		
		return 1.0f - (float)difference / (float)MAX_SIMILAR_RANKS_DIFFERENCE;
	}

	/**
	 * Defines the maximal difference between similar ranks.
	 * @author Piotrek
	 */
	
	public static int MAX_SIMILAR_RANKS_DIFFERENCE = 3;
}
