/*
 * Created on 2005-04-15
 */
package gui;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * A file filter used to filter out the world files.
 * @author Piotrek
 */
public final class WorldEditorFileFilter extends FileFilter
{
	/**
	 * Constructor.
	 * @author Piotrek
	 */
	public WorldEditorFileFilter()
	{
		super();
	}
	
	/**
	 * A file extension for the world files.
	 * @author Piotrek
	 */
	public static final String FILE_EXTENSION = ".WorldXML";
	
	/**
	 * @author Piotrek
	 * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
	 */
	public boolean accept(File file) 
	{
		if (file.isDirectory()) 
		{
			return true;
		}
	
		String name = file.getName();
		
		if (name != null && name.endsWith(FILE_EXTENSION)) 
			return true;
		
		return false;
	}

	/**
	 * @author Piotrek
	 * @see javax.swing.filechooser.FileFilter#getDescription()
	 */
	public String getDescription()
	{
		return "World XML Files";
	}
}
