/*
 * Created on 2005-05-03
 */
package gui.controls;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import scheduler.TravelPartsList;

/**
 * A cell renderer used to display a travel division.
 * @author Piotrek
 */
public class TravelDivisionsCellRenderer extends JComponent implements ListCellRenderer
{
	/**
	 * Constructor.
	 * @author Piotrek
	 */
	public TravelDivisionsCellRenderer()
	{
		super();
				
		setLayout(null);
	}
	
	/**
	 * @author Piotrek
	 * @see javax.swing.ListCellRenderer#getListCellRendererComponent(javax.swing.JList, java.lang.Object, int, boolean, boolean)
	 */
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
	{
		division = (TravelPartsList)value;
		
		itemIndex = index + 1;
	       
		if (isSelected)
		{
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
		}
        else
        {
        	setBackground(list.getBackground());
        	setForeground(list.getForeground());
        }
		
		setEnabled(list.isEnabled());
		setFont(list.getFont());
	                
        return this;
	}
	
	/**
	 * A division we are rendering.
	 * @author Piotrek
	 */
	private TravelPartsList division = null;
	
	/**
	 * A one-based index on the list of the divisions we are rendering.
	 * @author Piotrek
	 */
	private int itemIndex = -1;
	
	/**
	 * @author Piotrek
	 * @see java.awt.Component#paint(java.awt.Graphics)
	 */
	public void paint(Graphics g)
	{
		g.setColor(getBackground());
		g.fillRect(0, 0 , getSize().width, getSize().height);
			
		g.setColor(Color.RED);
		g.drawString("Travel Division #" + itemIndex, 10, 20);
		
		g.setColor(Color.BLUE);
		g.drawString("(" + division.GetTravelPartsCount() + " part(s) / " + division.GetChangesCount() + " change(s))", 10, 40);
			
		if (itemIndex != 1)
			g.drawLine(0, 0, getWidth(), 0);
	}
}
