/*
 * Created on 2005-08-29
 */
package scheduler.modules;

import java.util.ArrayList;
import scheduler.TravelConstraints;
import scheduler.modulesinterfaces.FeedbackTravelPartsProvider;
import world.Location;
import world.MeanOfTransportation;

/**
 * A stub providing the feedback travel parts (expert knowledge).
 * @author Piotrek
 */
public final class FeedbackTravelPartsProviderStub implements	FeedbackTravelPartsProvider
{
	/**
	 * @author Piotrek
	 * @see scheduler.modulesinterfaces.FeedbackTravelPartsProvider#GetFeedbackTravelParts(world.Location, world.Location, int)
	 */
	public ArrayList GetFeedbackTravelParts(Location origin, Location destination, int meanOfTransportation)
	{
		if (origin == null)
			throw new NullPointerException("Origin must not be null in FeedbackTravelPartsProviderStub.GetFeedbackTravelParts().");
		
		if (destination == null)
			throw new NullPointerException("Destination must not be null in FeedbackTravelPartsProviderStub.GetFeedbackTravelParts().");
		
		if (!MeanOfTransportation.IsValidMeanOfTransportation(meanOfTransportation))
			throw new IllegalArgumentException("Invalid mean of transportation in FeedbackTravelPartsProviderStub.GetFeedbackTravelParts().");
		
		if (travelConstraints == null)
			throw new RuntimeException("Set the travel constrains first in FeedbackTravelPartsProviderStub.GetFeedbackTravelParts().");
		
		ArrayList feedbackTravelParts = new ArrayList();
		
		// TIP: add rules here (they may be loaded from some file)
				
		return feedbackTravelParts;
	}
	
	/**
	 * @author Piotrek
	 * @see FeedbackTravelPartsProvider#SetTravelConstraints(scheduler.TravelConstraints)
	 */
	public void SetTravelConstraints(TravelConstraints constraints)
	{
		if (constraints == null)
			throw new NullPointerException("Constraints must not be null in MeansOfTransportationChooserStub.SetTravelConstraints().");
		
		travelConstraints = constraints;
	}
	
	/**
	 * The current travel travelConstraints.
	 * @author Piotrek
	 */
	private TravelConstraints travelConstraints = null;
}
