/*
 * Created on 2005-08-30
 */
package scheduler.modulesinterfaces;

import scheduler.ConnectionsFinderTask;

/**
 * An interface that must be implemented by a class that will manage the order of processing of tasks while finding the connections for the travel divisions.
 * @author Piotrek
 */
public interface ConnectionsFinderTasksManager
{
	/**
	 * Adds a task to the manager to be stored for a later execution. It does not check if a given task has been already added in the past.
	 * @author Piotrek
	 * @param task A task to the manager to be stored for a later execution.
	 */
	public void AddTask(ConnectionsFinderTask task);
	
	/**
	 * Gets a task to be performed.
	 * @author Piotrek
	 * @return A task to be performed or null if there are no more.
	 */
	public ConnectionsFinderTask GetTask();
	
	/**
	 * Removes all the tasks from the manager.
	 * @author Piotrek
	 */
	public void Clear();
}
