/*
 * Created on 2005-05-12
 */
package tests;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * A test suite containing all the tests for the scheduler and the world objects.
 * @author Piotrek
 */
public class AllWorldSchedulerTests
{
	/**
	 * Runs the tests in the GUI mode.
	 * @author Piotrek
	 * @param args The arguments.
	 */
	public static void main(String[] args)
	{
		junit.swingui.TestRunner.run(AllWorldSchedulerTests.class);
	}

	/**
	 * Gets a test suite to be performed.
	 * @author Piotrek
	 * @return A test suite to be performed.
	 */
	public static Test suite()
	{
		TestSuite suite = new TestSuite("Test for tests");
		//$JUnit-BEGIN$
		// world tests
		suite.addTestSuite(LocationTest.class);
		suite.addTestSuite(MeanOfTransportationTest.class);
		suite.addTestSuite(WorldObjectTest.class);
		suite.addTestSuite(StationTest.class);
		suite.addTestSuite(AirportTest.class);
		suite.addTestSuite(BusStopTest.class);
		suite.addTestSuite(TrainStationTest.class);
		suite.addTestSuite(HarbourTest.class);
		suite.addTestSuite(TravelTimeTest.class);
		suite.addTestSuite(ConnectionTest.class);
		suite.addTestSuite(WorldTest.class);
		
		// scheduler tests
		suite.addTestSuite(TravelPartTest.class);
		suite.addTestSuite(TravelPartsListTest.class);
		suite.addTestSuite(TravelPartsGeneratorTest.class);
		suite.addTestSuite(ConnectionsFinderTaskTest.class);
		suite.addTestSuite(TravelDivisionsConnectionsFinderTest.class);
		suite.addTestSuite(ConnectionsFinderTasksManagerTest.class);
		suite.addTestSuite(TravelPartConnectionChunkTest.class);
		suite.addTestSuite(MeansOfTransportationProviderTest.class);
		
		// CRN tests
		suite.addTestSuite(CaseTest.class);
		suite.addTestSuite(CRNTest.class);
		suite.addTestSuite(IESpecificComparisonManagerTest.class);
		suite.addTestSuite(IETest.class);
		suite.addTestSuite(IEImportanceTest.class);
		// comparators
		suite.addTestSuite(ChangesCountsComparatorTest.class);
		suite.addTestSuite(DepartureHoursOfDayComparatorTest.class);
		suite.addTestSuite(RanksComparatorTest.class);
		suite.addTestSuite(TotalDurationsComparatorTest.class);
		suite.addTestSuite(LocationsComparatorTest.class);
		//$JUnit-END$
		
		return suite;
	}
}
