/*
 * Created on 2005-05-31
 */
package tests;

import junit.framework.TestCase;
import scheduler.ConnectionsFinderTask;
import scheduler.modules.ConnectionsFinderTasksManager;

/**
 * Tests the ConnectionsFinderTasksManager class.
 * @author Piotrek
 */
public class ConnectionsFinderTasksManagerTest extends TestCase
{
	/**
	 * Tests the constructor.
	 * @author Piotrek
	 */
	public void testConnectionsFinderTasksManager()
	{
		try
		{
			new ConnectionsFinderTasksManager();
		}
		
		catch (Throwable t)
		{
			TestCase.fail("ConnectionsFinderTasksManager.ConnectionsFinderTasksManager() has thrown an exception.");
		}
	}

	/**
	 * Tests adding of the tasks.
	 * @author Piotrek
	 */
	public void testAddTask()
	{
		ConnectionsFinderTasksManager manager = new ConnectionsFinderTasksManager();
		
		boolean fThrown = false;
		
		try
		{
			manager.AddTask(null);
		}
		
		catch (NullPointerException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("ConnectionsFinderTasksManager.AddTask() is not checking its parameter properly.");
		
		ConnectionsFinderTask task1 = new ConnectionsFinderTask();
		ConnectionsFinderTask task2 = new ConnectionsFinderTask();
		ConnectionsFinderTask task3 = new ConnectionsFinderTask();
		
		try
		{
			manager.AddTask(task1);
			manager.AddTask(task2);
			manager.AddTask(task3);
		}
		
		catch (Throwable t)
		{
			TestCase.fail("ConnectionsFinderTasksManager.AddTask() has thrown an exception while adding valid tasks.");
		}
	}

	/**
	 * Tests getting of the tasks.
	 * @author Piotrek
	 */
	public void testGetTask()
	{
		ConnectionsFinderTasksManager manager = new ConnectionsFinderTasksManager();
		
		ConnectionsFinderTask task1 = new ConnectionsFinderTask();
		ConnectionsFinderTask task2 = new ConnectionsFinderTask();
		ConnectionsFinderTask task3 = new ConnectionsFinderTask();
		
		manager.AddTask(task1);
		manager.AddTask(task2);
		manager.AddTask(task3);
		
		if (manager.GetTask() != task3)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		if (manager.GetTask() != task2)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		manager.AddTask(task3);
		
		if (manager.GetTask() != task3)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		manager.AddTask(task3);
		manager.AddTask(task2);
		
		if (manager.GetTask() != task2)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		if (manager.GetTask() != task3)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		if (manager.GetTask() != task1)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
		
		if (manager.GetTask() != null)
			TestCase.fail("ConnectionsFinderTasksManager.GetTask() is not working properly.");
	}

	/**
	 * Tests getting of the tasks count.
	 * @author Piotrek
	 */
	public void testGetTasksCount()
	{
		ConnectionsFinderTasksManager manager = new ConnectionsFinderTasksManager();
		
		ConnectionsFinderTask task1 = new ConnectionsFinderTask();
		ConnectionsFinderTask task2 = new ConnectionsFinderTask();
		ConnectionsFinderTask task3 = new ConnectionsFinderTask();
		
		if (manager.GetTasksCount() != 0)
			TestCase.fail("ConnectionsFinderTasksManager.GetTasksCount() is not working properly.");
		
		manager.AddTask(task1);
		
		if (manager.GetTasksCount() != 1)
			TestCase.fail("ConnectionsFinderTasksManager.GetTasksCount() is not working properly.");
		
		manager.AddTask(task2);
		
		if (manager.GetTasksCount() != 2)
			TestCase.fail("ConnectionsFinderTasksManager.GetTasksCount() is not working properly.");
		
		manager.AddTask(task3);
		
		if (manager.GetTasksCount() != 3)
			TestCase.fail("ConnectionsFinderTasksManager.GetTasksCount() is not working properly.");
		
		if (manager.GetTasksCount() != 3)
			TestCase.fail("ConnectionsFinderTasksManager.GetTasksCount() is not working properly.");
	}
}
