/*
 * Created on 2005-06-12
 */
package tests;

import crn.IEImportance;
import junit.framework.TestCase;

/**
 * @author Piotrek
 */
public class IEImportanceTest extends TestCase
{
	/**
	 * Tests the weights values for the importance levels.
	 * @author Piotrek
	 */
	public void testConstantValues()
	{
		if (IEImportance.NONE < 0.0f)
			TestCase.fail("IEImportance.NONE is negative.");
		
		if (IEImportance.IRRELEVANT < 0.0f)
			TestCase.fail("IEImportance.IRRELEVANT is negative.");
		
		if (IEImportance.UNIMPORTANT < 0.0f)
			TestCase.fail("IEImportance.UNIMPORTANT is negative.");
		
		if (IEImportance.NEUTRAL < 0.0f)
			TestCase.fail("IEImportance.NEUTRAL is negative.");
		
		if (IEImportance.IMPORTANT < 0.0f)
			TestCase.fail("IEImportance.IMPORTANT is negative.");
		
		if (IEImportance.CRUCIAL < 0.0f)
			TestCase.fail("IEImportance.CRUCIAL is negative.");
		
		if (IEImportance.IRRELEVANT <= IEImportance.NONE)
			TestCase.fail("IEImportance.IRRELEVANT is not greater then IEImportance.NONE.");
		
		if (IEImportance.UNIMPORTANT <= IEImportance.IRRELEVANT)
			TestCase.fail("IEImportance.UNIMPORTANT is not greater then IEImportance.IRRELEVANT.");
		
		if (IEImportance.NEUTRAL <= IEImportance.UNIMPORTANT)
			TestCase.fail("IEImportance.NEUTRAL is not greater then IEImportance.UNIMPORTANT.");
		
		if (IEImportance.IMPORTANT <= IEImportance.NEUTRAL)
			TestCase.fail("IEImportance.IMPORTANT is not greater then IEImportance.NEUTRAL.");
		
		if (IEImportance.CRUCIAL <= IEImportance.IMPORTANT)
			TestCase.fail("IEImportance.CRUCIAL is not greater then IEImportance.IMPORTANT.");
	}
}
