/*
 * Created on 2005-06-19
 */
package tests;

import junit.framework.TestCase;
import crn.IE;
import crn.comparators.LocationsComparator;

/**
 * Tests the locations comparator.
 * @author Piotrek
 */
public class LocationsComparatorTest extends TestCase
{
	/**
	 * Tests the comparison method.
	 * @author Piotrek
	 */
	public void testCompareIEs()
	{
		LocationsComparator comparator = new LocationsComparator();
		
		IE ie1 = new IE("Origin", "1;1");
		IE ie2 = new IE("Origin", "5;4");
		IE ie3 = new IE("Test", "1;3;4");
		
		boolean fThrown = false;
		
		try
		{
			comparator.CompareIEs(null, null);
		}
		
		catch (NullPointerException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("Locations comparator is not validating its parameters properly.");
		
		fThrown = false;
		
		try
		{
			comparator.CompareIEs(ie1, null);
		}
		
		catch (NullPointerException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("Locations comparator is not validating its parameters properly.");
		
		fThrown = false;
		
		try
		{
			comparator.CompareIEs(null, ie2);
		}
		
		catch (NullPointerException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("Locations comparator is not validating its parameters properly.");
		
		fThrown = false;
		
		try
		{
			comparator.CompareIEs(ie1, ie3);
		}
		
		catch (IllegalArgumentException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("Locations comparator is not validating its parameters properly.");
		
		fThrown = false;
		
		try
		{
			comparator.CompareIEs(ie3, ie1);
		}
		
		catch (IllegalArgumentException xcp)
		{
			fThrown = true;
		}
		
		if (!fThrown)
			TestCase.fail("Locations comparator is not validating its parameters properly.");
		
		if (comparator.CompareIEs(ie1, ie1) != 1)
			TestCase.fail("Locations comparator is not working properly.");
		
		if (comparator.CompareIEs(ie1, ie2) >= 1.0)
			TestCase.fail("Locations comparator is not working properly.");
		
		if (comparator.CompareIEs(ie1, ie2) <= 0.0)
			TestCase.fail("Locations comparator is not working properly.");
		
		if (comparator.CompareIEs(ie2, ie1) >= 1.0)
			TestCase.fail("Locations comparator is not working properly.");
		
		if (comparator.CompareIEs(ie2, ie1) <= 0.0)
			TestCase.fail("Locations comparator is not working properly.");
	}
	
	/**
	 * Tests the initial value of the MAX_SIMILAR_LOCATIONS_DISTANCE constant.
	 * @author Piotrek
	 */
	public void testMaxSimilarRanks()
	{
		if (LocationsComparator.MAX_SIMILAR_LOCATIONS_DISTANCE <= 0)
			TestCase.fail("MAX_SIMILAR_LOCATIONS_DISTANCE must be positive.");
	}
}
