/*
 * Created on 2005-05-14
 */
package tests;

import java.lang.reflect.Field;
import junit.framework.TestCase;
import world.MeanOfTransportation;

/**
 * Tests the MeanOfTransportation class.
 * @author Piotrek
 */
public class MeanOfTransportationTest extends TestCase
{
	/**
	 * Tests the validity test.
	 * @author Piotrek
	 */
	public void testIsValidMeanOfTransportation()
	{
		Field[] fields = MeanOfTransportation.class.getDeclaredFields();
		
		for (int i = 0; i < fields.length; ++i)
		{
			try
			{
				if (fields[i].getType() == int.class)
					if (!MeanOfTransportation.IsValidMeanOfTransportation(fields[i].getInt(fields[i])))
						TestCase.fail(fields[i].getName() + " is not a valid mean of transportation accordingly to the dedicated method.");
			}
			
			catch (IllegalAccessException xcp)
			{
				TestCase.fail("Unexcpected exception: " + xcp.getMessage());
			}
		}
	}

	/**
	 * Tests the mean of transportation name to code convertion.
	 * @author Piotrek
	 */
	public void testGetMeanOfTransportationConvertions()
	{
		Field[] fields = MeanOfTransportation.class.getDeclaredFields();
		
		for (int i = 0; i < fields.length; ++i)
		{
			try
			{
				if (fields[i].getType() == int.class)
				{
					int code = fields[i].getInt(fields[i]);
					
					String name = "????";
					
					try
					{
						name = MeanOfTransportation.GetMeanOfTransportationString(code);
					}
					
					catch (IllegalArgumentException xcp)
					{
						TestCase.fail("There is no name for the " + code + " mean of transportation code.");
					}
					
					int code2 = -1;
					
					try
					{
						code2 = MeanOfTransportation.GetMeanOfTransportationCode(name);
					}
					
					catch (IllegalArgumentException xcp)
					{
						TestCase.fail("There is no code for the mean of transportaion of `" + name + "'.");
					}
					
					if (code != code2)
						TestCase.fail("The code returned for the name `" + name + "' is different then the one used to get that name (" + code + ").");
				}
			}
			
			catch (IllegalAccessException xcp)
			{
				TestCase.fail("Unexcpected exception: " + xcp.getMessage());
			}
		}
	}
}
