/*
 * Created on 2005-09-06
 */
package tests;

import junit.framework.TestCase;
import scheduler.modulesinterfaces.MeansOfTransportationProvider;

/**
 * Tests the constant values in the MeansOfTransportationProvider interface.
 * @author Piotrek
 */
public class MeansOfTransportationProviderTest extends TestCase
{
	/**
	 * Tests the max walk and taxi distances.
	 * @author Piotrek
	 */
	public void testWalkAndTaxiDistances()
	{
		if (MeansOfTransportationProvider.MAX_WALK_DISTANCE >= MeansOfTransportationProvider.MAX_TAXI_DISTANCE)
			TestCase.fail("MeansOfTransportationProvider.MAX_WALK_DISTANCE must be smaller then TravelPartsGenerator.MAX_TAXI_DISTANCE.");
	}
	
	/**
	 * Tests the min and max distances for each of the means of transportation.
	 * @author Piotrek
	 */
	public void testMinAndMaxDistances()
	{
		if (MeansOfTransportationProvider.MIN_BUS_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MIN_BUS_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MIN_CRUISE_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MIN_CRUISE_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MIN_FLIGHT_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MIN_FLIGHT_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MIN_TAXI_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MIN_TAXI_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MIN_TRAIN_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MIN_TRAIN_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MAX_TAXI_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MAX_TAXI_DISTANCE must not be negative.");
		
		if (MeansOfTransportationProvider.MAX_WALK_DISTANCE < 0)
			TestCase.fail("MeansOfTransportationProvider.MAX_WALK_DISTANCE must not be negative.");
	}
}
