/*
 * Created on 2005-04-06
 */
package world;

/**
 * A world object.
 * @author Piotrek
 */
public class WorldObject
{
	/**
	 * A location of this world object.
	 * @author Piotrek
	 */
	private Location location = null;
	
	/**
	 * Constructor.
	 * @author Piotrek
	 * @param location A location of the new world object.
	 * @param name A name of this world object.
	 */
	public WorldObject(Location location, String name)
	{
		if (location == null)
			throw new NullPointerException("A location must not be null in WorldObject.WorldObject().");
		
		if (name == null)
			throw new NullPointerException("A name must not be null in WorldObject.WorldObject().");
		
		this.location = location;
		
		this.name = name;
	}
	
	/**
	 * Gets the location of this world object.
	 * @author Piotrek
	 * @return The location of this world object.
	 */
	public Location GetLocation()
	{
		return location;
	}
	
	/**
	 * A name of this world object.
	 * @author Piotrek
	 */
	public String name = "";
}
